#!/usr/bin/env groovy

node {
    stage('Checkout') {
        checkout scm
        def pom = readMavenPom file: 'pom.xml'
        if (pom) {
        echo "Building version ${pom.version}"
        }
    }

    stage('Build') {
		withMaven(globalMavenSettingsConfig: '', jdk: 'Java 17', maven: 'Maven 3.9.2', mavenSettingsConfig: '', traceability: true) {
			sh "mvn compile"
		}
	}

    stage('Tests') {
		withMaven(jdk: 'Java 17', maven: 'Maven 3.9.2') {
		    if (params.SKIP_TESTS) {
			    echo "Pas d'exécution des tests unitaires : ${env.SKIP_TESTS}"
		    } else {
			    echo "Exécution des tests unitaires : ${env.SKIP_TESTS}"
			    sh "mvn test"
		    }
		}
	}

    stage("build & SonarQube analysis") {
		withMaven(jdk: 'Java 17', maven: 'Maven 3.9.2') {
		    withSonarQubeEnv('SonarCloud') {
			    sh 'mvn sonar:sonar -Dsonar.projectKey=marc-gyver_jenkins'
				sh 'mvn clean verify org.sonarsource.scanner.maven:sonar-maven-plugin:sonar -Dsonar.projectKey=marc-gyver_jenkins'
		    }
		}
	}

	stage("Package") {
		archiveArtifacts artifacts: '**/target/*.*'
	}

	stage('Build') {
		parallel 'build': {
			withEnv(["PATH+jdk=${tool 'JDK 11'}/bin"]) {
				sh "./mvnw compile"
				archiveArtifacts artifacts: '**/target/*.*'
			}
		}, 'Hello World': {
			echo 'Hello World'
		}
	}

}
